/*
 * Vertical and horizontal boxes.
 *
 */

#ifndef __CBOX_H__
#define __CBOX_H__

#include "stdafx.h"
#include "WindowVirt.h"
#include <vector>


#ifndef RESIZE_NONE
#define RESIZE_PROPERTY_HORIZ TEXT("RPropHoriz")
#define RESIZE_PROPERTY_VERT  TEXT("RPropVert")
#define RESIZE_PROPERTY_ORIGSIZE TEXT("RPropOrig")
#define RESIZE_NONE       1
#define RESIZE_CENTER     2
#define RESIZE_NORMAL     3
#endif

typedef CWinTraits < WS_CHILD | WS_VISIBLE | BS_GROUPBOX, WS_EX_NOPARENTNOTIFY > BoxTraits;

class CBox : public CWindowImpl<CBox, CWindowVirt, BoxTraits >
{
public:
   DECLARE_WND_SUPERCLASS_BRUSH(NULL, _T("BUTTON"), COLOR_WINDOW+1)

   CBox();
   CBox(bool isVertical);
   virtual ~CBox();
   
   HWND Create(LPCTSTR szLabel, int width, int height, HWND hWndParent);

	BEGIN_MSG_MAP(CBox)
        MESSAGE_HANDLER(WM_SIZE, OnSize)
        MESSAGE_HANDLER(WM_ERASEBKGND, OnBgErase)
        MESSAGE_HANDLER(WM_COMMAND, OnPropagateCmd)
        MESSAGE_HANDLER(WM_NOTIFY, OnPropagateCmd)
        MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
    END_MSG_MAP()

    void CalcLayout();

    LRESULT OnBgErase(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled);
    LRESULT OnPropagateCmd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    void AddChild(CWindowVirt* ch);

protected:
    bool m_isVertical;
    int  m_wGap, m_hGap;
    bool m_initialized, m_shuttingDown;
    RECT rc;
    std::vector<CWindowVirt*>* m_children;

    void RemoveProps(HWND hWnd);

    SIZE HResize(int width, int height);
    SIZE VResize(int width, int height);
};

#endif /* __CBOX_H__ */
