// PanViewWindow.cpp: implementation of the CPanViewWindow class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PanViewWindow.h"
#include "Box.h"

// #define BOOL2bool(x) ((x) ? true : false)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPanViewWindow::CPanViewWindow ( HWND             hWndParent
                               , CComQIPtr<IPanImage> disper
                               , bool             timeVarying
                               , int              nWidth
                               , int              nHeight
                               , int*             pDisplayPasses
                               , double*          pMaxJitter
                               , CPerfData*       pData
                               , CMouseUpdater*   pMouseUpdater)
    : CViewWindow(pDisplayPasses, pMaxJitter,pMouseUpdater,timeVarying)
{
    SIZE* pSize;
    RECT r;

    // (conal) experiment: add four to width&height to counteract
    // mysterious shrinkage.
    nWidth+=4; nHeight+=4;

    r.top = r.left = 0;
    r.bottom = nHeight;
    r.right = nWidth;

    Create(hWndParent, r);

    m_image = new CImageView(disper,timeVarying,pData);

    //
    // Set up properties for the box layout container to make
    // good use of:
    //
    //    * stretchable in both directions.
    //    * original size == user specified size.
    SetProp(m_hWnd, RESIZE_PROPERTY_VERT, (HANDLE)RESIZE_NORMAL);
    SetProp(m_hWnd, RESIZE_PROPERTY_HORIZ,  (HANDLE)RESIZE_NORMAL);
  
    pSize = (SIZE*)malloc(sizeof(SIZE));
    if (pSize) {
        pSize->cx = nWidth;
        pSize->cy = nHeight;
        SetProp(m_hWnd, RESIZE_PROPERTY_ORIGSIZE, (HANDLE)pSize);
    }

    Changed();

}


CPanViewWindow::~CPanViewWindow()
{
}


#if 0  // merged functionality into parent class

// ToDo: Shouldn't this guy be in the parent class (CViewWindow)?
LRESULT CPanViewWindow::OnTimer(UINT uMsg, WPARAM timerId, LPARAM lParam, BOOL& bHandled)
{
    if (timerId == animateTimer)
        TriggerDisplayPass();
    else
        bHandled = FALSE;
    return 0;
}


// Period in MS for time-varying images
// static const double framesPerSecond = 35.0;

// ToDo: merge animation and progressive display timers.

void CPanViewWindow::Redisplay()
{
    // Start or stop the timer if necessary.
    if (m_timeVarying && m_hWnd) {
        SetTimer(animateTimer,
                 // (int) (1000 / framesPerSecond)
                 30
            );
    }
    else if (!m_timeVarying && m_timerRunning && m_hWnd) {
        KillTimer(animateTimer);
    }

    if (m_hWnd) {
      m_timerRunning = m_timeVarying;
      InvalidateRect(NULL,TRUE);
    }

    m_image->Redisplay();
}

#endif
